/*
 License (it is a PNG/ZLIB license)

Copyright (c) 2006 Victor Hugo Soliz Kuncar

This software is provided 'as-is', without any express or implied warranty. In no event will the authors be held liable for any damages arising from the use of this software.

Permission is granted to anyone to use this software for any purpose, including commercial applications, and to alter it and redistribute it freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not claim that you wrote the original software. If you use this software in a product, an acknowledgment in the product documentation would be appreciated but is not required.

    2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.

    3. This notice may not be removed or altered from any source distribution.

*/

/*todo:

    * Modularize xye.cpp so we don't have 1000 classes in the same file
    * Figure out a good excuse for this main.cpp file
    * GUI
    * Editor
    * More objects


*/

#include "xye.h"
#include "xye_script.h"
#include "options.h"

#include "browser.h"


#include <sys/types.h>
#include <sys/stat.h>

#ifdef _WIN32
 #define MKDIR(d, p) mkdir(d)
#else
 #define MKDIR mkdir
#endif


bool TryToOpenFolder(const char* path)
{
    Folder F(path);
    if (F.Open())
    {
        F.Close();
        return true;
    }
    return false;
}

int main ( int argc, char** argv )
{


    if (argc>1)
         options::Dir=argv[1];
    else
    {
    #ifdef DATA_PATH
        options::Dir=DATA_PATH;
    #else
        options::Dir="./";
    #endif
    }
    char* pn=string2charp(&options::Dir);
    printf("Will look on %s for data files (non-user levels, skins)\n",pn);


    if (! TryToOpenFolder(pn))
    {
        delete[] pn;
        printf("Exception: Can't open/find data folder\n");
        return 1;
    }

    if ( strlen(pn) && (pn[strlen(pn)-1]!='/')) options::Dir+='/'; //for safety
    delete[] pn;

const char* home;
if (home=getenv("HOME"))
{
    printf("initializing home:\n");
    char* tmloc=new char[strlen(home)+strlen("/.xye/")+1];
    strcpy(tmloc,home);strcat(tmloc,"/.xye/");


    if (TryToOpenFolder(tmloc))
        printf("Found: %s\n",tmloc);
    else
    {
        printf("attempt to create %s : ",tmloc);
        if (MKDIR(tmloc,S_IRWXU)>=0)
            printf("ok\n");
        else
            printf("failed, errors might happen\n");
    }
    delete [] tmloc;

    tmloc=new char[strlen(home)+strlen("/.xye/levels/")+1];
    strcpy(tmloc,home);strcat(tmloc,"/.xye/levels/");

    if (TryToOpenFolder(tmloc))
        printf("Found: %s\n",tmloc);
    else
    {
        printf("attempt to create %s : ",tmloc);
        if (MKDIR(tmloc,S_IRWXU)>=0)
            printf("ok\n");
        else
            printf("failed, errors might happen\n");
    }
    delete [] tmloc;

    tmloc=new char[strlen(home)+strlen("/.xye/res/")+1];
    strcpy(tmloc,home);strcat(tmloc,"/.xye/res/");


    if (TryToOpenFolder(tmloc))
        printf("Found: %s\n",tmloc);
    else
    {
        printf("attempt to create %s : ",tmloc);
        if (MKDIR(tmloc,S_IRWXU)>=0)
            printf("ok\n");
        else
            printf("failed, errors might happen\n");
    }
    delete [] tmloc;



}
else
    printf("no home folder found, this probably is a win32 build. If there is a home folder in your system then xye is having problems to detect it, make sure to have a correct home environment variable.");


printf("Initializing game...\n");
   game::Init();

return 0;
}
